.nolist
include \masm32\include\masm32rt.inc

ShellWait	PROTO: DWORD, :DWORD, :DWORD

Launch MACRO cmd:REQ, showSW:=<0>, timeout:=<INFINITE>
LOCAL ShowMode
  ShowMode equ <showSW>
  if showSW eq SW_HIDE and @SizeStr(showSW) eq 7
	ShowMode equ <SW_HIDE or 65536>
  endif
  invoke ShellWait, addr cmd, ShowMode, timeout
  ENDM
.code

PathAndCmd		db "C:\WINDOWS\notepad.exe C:\WINDOWS\SYSTEM.INI", 0
AppName  	db "ShellWait:", 0

start:	Launch PathAndCmd	;, SW_MAXIMIZE, 2000	; optional: SW_x, timeout
	.if eax
		.if ecx==STILL_ACTIVE
			invoke MessageBox, 0, addr PathAndCmd, chr$("The process is still active!"), MB_OK
		.elseif ecx
			invoke MessageBox, 0, str$(ecx), chr$("We are done with this exit code:"), MB_OK
		.endif
	  .else
		invoke MessageBox, 0, addr PathAndCmd, chr$("Something went wrong:"), MB_OK
	.endif
	invoke ExitProcess, 0

ShellWait proc cmdline:DWORD, SW_x:DWORD, timeout:DWORD
LOCAL ExCode:DWORD		; exit code, returned in ecx
LOCAL sinfo:STARTUPINFO
LOCAL pinfo:PROCESS_INFORMATION
  invoke GetStartupInfo, addr sinfo			; fill the structure
  mov eax, SW_x
  .if eax
	mov sinfo.dwFlags, STARTF_USESHOWWINDOW			; these two are
	mov sinfo.wShowWindow, ax				; optional but useful
  .endif
  xor ecx, ecx			; using ecx as NULL saves some bytes
  mov ExCode, ecx			; exit code valid only if eax!=0
  invoke CreateProcess, ecx,	; no pathname
  cmdline,				; the only bit that REALLY counts...!
  ecx, ecx, ecx,		; lpProcessAttributes, lpThreadAttributes, bInheritHandles
  ecx, ecx, ecx,		; xx_PRIORITY_CLASS, lpEnvironment, lpCurrentDirectory
  addr sinfo,		; read from STARTUPINFO
  addr pinfo		; write to PROCESS_INFORMATION
  mov eax, pinfo.hProcess		; wow, we got a handle! Actually, we got two...
  .if eax
	invoke WaitForSingleObject, eax, timeout	; specify milliseconds here
	invoke GetExitCodeProcess, pinfo.hProcess, addr ExCode
	invoke CloseHandle, pinfo.hProcess
	invoke CloseHandle, pinfo.hThread
	mov eax, pinfo.hProcess

	lea ecx, pinfo
	call OneDown
	.if eax==pinfo.hProcess
		invoke MessageBox, 0, chr$("Passing the pointer worked!"), chr$("Test"), MB_OK
	.endif
  .endif
  mov ecx, ExCode
  ret
ShellWait endp

OneDown proc
  mov eax, [ecx.PROCESS_INFORMATION.hProcess]
  ret
OneDown endp

end start

OPT_Icon		Eye
OPT_Linker	polink
OPT_DelTmp	0
OPT_SUSY	Windows
